// offscrnView.cpp : COffscrnView NX̓̒`s܂B
//

#include "stdafx.h"
#include "offscrn.h"

#include "offscrnDoc.h"
#include "offscrnView.h"

#include <GL/gl.h>
#include <GL/glu.h>

#include <math.h>

#ifndef	M_PI
#	define	M_PI	3.1415926
#endif	/* M_PI */

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// COffscrnView

IMPLEMENT_DYNCREATE(COffscrnView, CView)

BEGIN_MESSAGE_MAP(COffscrnView, CView)
	//{{AFX_MSG_MAP(COffscrnView)
	ON_WM_CREATE()
	ON_WM_SIZE()
	ON_WM_DESTROY()
	ON_WM_ERASEBKGND()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// COffscrnView NX̍\z/

COffscrnView::COffscrnView()
{
	// TODO: ̏ꏊɍ\zp̃R[hǉĂB

}

COffscrnView::~COffscrnView()
{
}

BOOL COffscrnView::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: ̈ʒu CREATESTRUCT cs C Window NX܂̓X^C
	//  CĂB

	cs.style |= WS_CLIPSIBLINGS | WS_CLIPCHILDREN;

	return CView::PreCreateWindow(cs);
}

/////////////////////////////////////////////////////////////////////////////
// COffscrnView NX̕`

void COffscrnView::OnDraw(CDC* pDC)
{
	COffscrnDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);
	// TODO: ̏ꏊɃlCeBu f[^p̕`R[hǉ܂B

	::wglMakeCurrent(m_hDC, m_hRC);

	::glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);

	::glPushMatrix();

	::gluLookAt(
		0.0f, 0.0f, 600.0f,
		0.0f, 0.0f, 0.0f,
		0.0f, 1.0f, 0.0f
	);

	GLfloat	pos[]		= {1800.0f, 1800.0f, 2300.0f, 1.0f};
	GLfloat	col_amb[]	= {0.2f, 0.2f, 0.2f, 1.0f};
	GLfloat	col_diff[]	= {1.0f, 1.0f, 1.0f, 1.0f};
	GLfloat	col_spec[]	= {1.0f, 1.0f, 1.0f, 1.0f};

	::glLightfv(GL_LIGHT1, GL_AMBIENT, col_amb);
	::glLightfv(GL_LIGHT1, GL_DIFFUSE, col_diff);
	::glLightfv(GL_LIGHT1, GL_SPECULAR, col_spec);
	::glLightfv(GL_LIGHT1, GL_POSITION, pos);


	GLfloat	mat_ambient[]  = {0.15f, 0.15f, 0.70f, 1.0f};
	GLfloat	mat_diffuse[]  = {0.15f, 0.15f, 0.70f, 1.0f};
	GLfloat	mat_specular[] = {1.0f, 1.0f, 1.0f, 1.0f};

	::glMaterialfv(GL_FRONT, GL_AMBIENT, mat_ambient);
	::glMaterialfv(GL_FRONT, GL_DIFFUSE, mat_diffuse);
	::glMaterialfv(GL_FRONT, GL_SPECULAR, mat_specular);
	::glMaterialf(GL_FRONT, GL_SHININESS, 64.0);

	::glPushMatrix();
	DrawSphere(200.0);
	::glPopMatrix();

	::glPopMatrix();
	::glFlush();

	::wglMakeCurrent(NULL, NULL);

	/* DIB  Window ɃRs[ */

	::SetStretchBltMode(pDC->m_hDC, COLORONCOLOR);

	::StretchDIBits(
		pDC->m_hDC,
		0, 0, m_DIBWidth, m_DIBHeight,
		0, 0, m_DIBWidth, m_DIBHeight,
		m_PBits,
		(BITMAPINFO*)m_PBIH,
		DIB_RGB_COLORS,
		SRCCOPY
	);
}

/////////////////////////////////////////////////////////////////////////////
// COffscrnView NX̐ff

#ifdef _DEBUG
void COffscrnView::AssertValid() const
{
	CView::AssertValid();
}

void COffscrnView::Dump(CDumpContext& dc) const
{
	CView::Dump(dc);
}

COffscrnDoc* COffscrnView::GetDocument() // fobO o[W̓CCłB
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(COffscrnDoc)));
	return (COffscrnDoc*)m_pDocument;
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// COffscrnView NX̃bZ[W nh

int COffscrnView::OnCreate(LPCREATESTRUCT lpCreateStruct) 
{
	if (CView::OnCreate(lpCreateStruct) == -1)
		return -1;
	
	// TODO: ̈ʒuɌŗL̍쐬pR[hǉĂ

	PIXELFORMATDESCRIPTOR pfd = { 
		sizeof(PIXELFORMATDESCRIPTOR),  //  size of this pfd 
		1,                     // version number 
		PFD_DRAW_TO_BITMAP |   // BITMAP w肷邱
		PFD_SUPPORT_OPENGL,    // support OpenGL 
		PFD_TYPE_RGBA,         // RGBA type 
		24,                    // 24-bit color depth 
		0, 0, 0, 0, 0, 0,      // color bits ignored 
		0,                     // no alpha buffer 
		0,                     // shift bit ignored 
		0,                     // no accumulation buffer 
		0, 0, 0, 0,            // accum bits ignored 
		32,                    // 32-bit z-buffer     
		0,                     // no stencil buffer 
		0,                     // no auxiliary buffer 
		PFD_MAIN_PLANE,        // main layer 
		0,                     // reserved 
		0, 0, 0                // layer masks ignored 
	}; 

	m_hDC = ::CreateCompatibleDC(NULL);

	m_DIBWidth = 640;
	m_DIBHeight = 480;
	m_BPP = 24;

	// Create BITMAPINFOHEADER
	m_PBIH = new BITMAPINFOHEADER;
	int iSize = sizeof(BITMAPINFOHEADER);
	::memset(m_PBIH, 0, iSize);

	m_PBIH->biSize = sizeof(BITMAPINFOHEADER);
	m_PBIH->biWidth = m_DIBWidth;
	m_PBIH->biHeight = m_DIBHeight;
	m_PBIH->biPlanes = 1;
	m_PBIH->biBitCount = m_BPP;
	m_PBIH->biCompression = BI_RGB;

	// Create DIB
	m_hbitmap = ::CreateDIBSection(
		m_hDC,
		(BITMAPINFO*)m_PBIH, DIB_RGB_COLORS,
		&m_PBits, NULL, 0
	);

	// Select the new bitmap into the buffer DC
	if (m_hbitmap) {
		m_hbitmap_old = (HBITMAP)::SelectObject(m_hDC, m_hbitmap);
	}
	else {
		MessageBox(_T("sł"), _T("G["), MB_ICONSTOP | MB_OK);
	}


	int  iPixelFormat; 
 
	iPixelFormat = ::ChoosePixelFormat(m_hDC, &pfd);

	BOOL success = ::SetPixelFormat(m_hDC, iPixelFormat, &pfd);

	m_hRC = ::wglCreateContext(m_hDC);


	::wglMakeCurrent(m_hDC, m_hRC);
 
	// ݒ
	InitOGL();

	::wglMakeCurrent(NULL, NULL);
	
	return 0;
}

void COffscrnView::OnSize(UINT nType, int cx, int cy) 
{
	CView::OnSize(nType, cx, cy);
	
	// TODO: ̈ʒuɃbZ[W nhp̃R[hǉĂ

	if (cx <= 0 || cy <= 0) {
		return;
	}

	/*  */
	m_DIBWidth = m_cx = cx;
	m_DIBHeight = m_cy = cy;

	m_PBIH->biSize = sizeof(BITMAPINFOHEADER);
	m_PBIH->biWidth = m_DIBWidth;
	m_PBIH->biHeight = m_DIBHeight;
	m_PBIH->biPlanes = 1;
	m_PBIH->biBitCount = m_BPP;
	m_PBIH->biCompression = BI_RGB;

	// Create DIB
	m_hbitmap = ::CreateDIBSection(
		m_hDC,
		(BITMAPINFO*)m_PBIH, 
		DIB_RGB_COLORS,
		&m_PBits, NULL, 0
	);

	// Select the new bitmap into the buffer DC
	if (m_hbitmap) {
		HBITMAP tmp_hbitmap = (HBITMAP)::SelectObject(m_hDC, m_hbitmap);
		if (tmp_hbitmap) {
			::DeleteObject(tmp_hbitmap);
		}
	}
	else {
		MessageBox(_T("sł"), _T("G["), MB_ICONSTOP | MB_OK);
	}


	::wglMakeCurrent(m_hDC, m_hRC);

	::glViewport(0, 0, m_DIBWidth, m_DIBHeight);

	::glMatrixMode(GL_PROJECTION);
	::glLoadIdentity(); 
	::gluPerspective(45.0f, (float)m_DIBWidth / m_DIBHeight, 1.0f, 2000.0f);
	::glMatrixMode(GL_MODELVIEW);
	::glLoadIdentity(); 
	
	::wglMakeCurrent(NULL, NULL);
}

void COffscrnView::OnDestroy() 
{
	CView::OnDestroy();
	
	// TODO: ̈ʒuɃbZ[W nhp̃R[hǉĂ
	HBITMAP tmp_hbitmap = (HBITMAP)::SelectObject(m_hDC, m_hbitmap_old);
	if (tmp_hbitmap) {
		::DeleteObject(tmp_hbitmap);
	}

	delete m_PBIH;

	DeleteDC(m_hDC);

	::wglDeleteContext(m_hRC);
}

BOOL COffscrnView::OnEraseBkgnd(CDC* pDC) 
{
	// TODO: ̈ʒuɃbZ[W nhp̃R[hǉ邩܂̓ftHg̏ĂяoĂ
	
//	return CView::OnEraseBkgnd(pDC);

	return TRUE;
}

void COffscrnView::InitOGL(void)
{
	::glClearColor(0.68f, 0.68f, 0.68f, 1.0f);

	::glShadeModel(GL_SMOOTH);
	::glEnable(GL_DEPTH_TEST);
	::glEnable(GL_CULL_FACE);
	::glEnable(GL_LIGHTING);
	::glEnable(GL_LIGHT1);

	::glLightModeli(GL_LIGHT_MODEL_LOCAL_VIEWER, GL_TRUE);
}

void COffscrnView::DrawSphere(double radius)
{
	double	theta, pai;
	double	co, si;
	double	co2, si2;
	double	r1, r2;
	double	h1, h2;

	for(pai = -90.0; pai < 90.0; pai += 10.0) {
		r1 = cos(pai * M_PI / 180.0);
		r2 = cos((pai + 10.0) * M_PI / 180.0);
		h1 = sin(pai * M_PI / 180.0);
		h2 = sin((pai + 10.0) * M_PI / 180.0);

		for(theta = 0.0; theta < 360.0; theta += 10.0) {
			co = cos(theta * M_PI / 180.0);
			si = sin(theta * M_PI / 180.0);
			co2 = cos((theta + 10.0) * M_PI / 180.0);
			si2 = sin((theta + 10.0) * M_PI / 180.0);

			::glBegin(GL_POLYGON);
			::glNormal3f((float)(r1 * co2), (float)h1, (float)(r1 * si2));
			::glVertex3f((float)(radius * r1 * co2), (float)(radius * h1), (float)(radius * r1 * si2));
			::glNormal3f((float)(r1 * co), (float)h1, (float)(r1 * si));
			::glVertex3f((float)(radius * r1 * co), (float)(radius * h1), (float)(radius * r1 * si));
			::glNormal3f((float)(r2 * co), (float)h2, (float)(r2 * si));
			::glVertex3f((float)(radius * r2 * co), (float)(radius * h2), (float)(radius * r2 * si));
			::glNormal3f((float)(r2 * co2), (float)h2, (float)(r2 * si2));
			::glVertex3f((float)(radius * r2 * co2), (float)(radius * h2), (float)(radius * r2 * si2));
			::glEnd();
		}
	}
}
